(function(global,factory){typeof exports==="object"&&typeof module!=="undefined"?factory(exports):typeof define==="function"&&define.amd?define(["exports"],factory):(global=typeof globalThis!=="undefined"?globalThis:global||self,factory(global.DecimalFormat={}))})(this,function(exports){"use strict";const RoundingMode={get Up(){return 0},get Down(){return 1},get Ceiling(){return 2},get Floor(){return 3},get HalfUp(){return 4},get HalfDown(){return 5},get HalfEven(){return 6},get Unnecessary(){return 7}};const formatCache={};const fmtReg=/[0#.,]/;const resolveFormat=pattern=>{var _a,_b;if(formatCache[pattern]){return formatCache[pattern]}const prefix=[];const suffix=[];let withSign=false;let percent=1;const fmt=[];let ch="";let state="PREFIX";let shouldEscape=false;let temp=[];function append(c,i){if(state==="PREFIX"){temp=prefix}else if(state==="FMT"){temp=fmt}else{temp=suffix}temp.push(c);if(shouldEscape){return}if(state==="PREFIX"&&["+","-"].includes(c)&&fmtReg.test(pattern[i+1])){temp.pop();withSign=true}if(suffix.length===1){if(suffix[0]==="%"){percent=100}else if(suffix[0]==="‰"){percent=1e3}}}function setState(c){if(state==="PREFIX"&&fmtReg.test(c)){state="FMT"}else if(state==="FMT"&&!fmtReg.test(c)){state="SUFFIX"}}for(let i=0;i<pattern.length;i++){ch=pattern[i];if(shouldEscape){append(ch,i);shouldEscape=false;continue}setState(ch);if(ch==="\\"){shouldEscape=true}else{append(ch,i)}}const prefixStr=prefix.join("");const fmtStr=fmt.join("");const suffixStr=suffix.join("");if(!fmtStr){formatCache[pattern]={suffix:suffixStr,prefix:prefixStr,percent:percent,thousandSeparate:3,withSign:withSign};return formatCache[pattern]}if(/\..*\./.test(fmtStr)){throw Error(`Multiple decimal separators in pattern "${pattern}"`)}const[intFmt,decimalFmt=""]=fmtStr.split(".");if(/[^0#]/.test(decimalFmt)){throw Error(`Malformed pattern "${pattern}"`)}if(decimalFmt.includes("#0")){throw Error(`Unexpected '0' in pattern "${pattern}"`)}if(intFmt.endsWith(",")){throw Error(`Malformed pattern "${pattern}"`)}if(/0.*#/.test(intFmt)){throw Error(`Unexpected '0' in pattern "${pattern}"`)}let thousandSeparate=0;const lastIndexOfSeperator=intFmt.lastIndexOf(",");if(lastIndexOfSeperator!==-1){thousandSeparate=intFmt.length-lastIndexOfSeperator-1}const trailingZeros=(_a=intFmt.replace(/,/g,"").match(/0*$/))===null||_a===void 0?void 0:_a[0];if(trailingZeros===undefined){throw Error(`Malformed pattern "${pattern}"`)}const{length:length}=trailingZeros;const maxScale=decimalFmt.length;const minScale=(_b=decimalFmt.match(/^0*/))===null||_b===void 0?void 0:_b[0].length;const radixPoint=fmtStr.endsWith(".");const config={prefix:prefixStr,suffix:suffixStr,percent:percent,thousandSeparate:thousandSeparate,maxScale:maxScale,minScale:minScale,length:length,radixPoint:radixPoint,withSign:withSign};formatCache[pattern]=config;return config};function convertToString(n){const nStr=`${n}`;if(nStr.includes("e")){const nArr=nStr.split("e");return enlarge(+nArr[0],+nArr[1])}return nStr}function shrink(n,multi){if(multi<0){return enlarge(n,-multi)}const nStr=convertToString(n);if(!multi){return nStr}return`${nStr}`.replace(/^-?/,`$&${"0".repeat(multi)}`).replace(new RegExp(`(\\d{${multi}})(\\.|$)`),".$1")}function enlarge(n,multi){if(multi<0){return shrink(n,-multi)}const nStr=convertToString(n);if(!multi){return nStr}const num=`${nStr}${"0".repeat(multi)}`;return num.replace(new RegExp(`\\.(\\d{${multi}})`),"$1.")}function adjust(n,scale){const num=convertToString(n);if(num.includes(".")){const arr=num.split(".");arr[1]=`${arr[1].padEnd(scale,"0")}1`;return+arr.join(".")}return n}function round(n,scale,roundingMode){let[int,decimal]=convertToString(n).split(".");const sign=n>0?"":"-";if(!decimal){return n.toFixed(scale)}decimal=decimal.padEnd(scale+1,"0");switch(roundingMode){case RoundingMode.Ceiling:{return shrink(Math.ceil(+enlarge(n,scale)),scale)}case RoundingMode.Floor:{return shrink(Math.floor(+enlarge(n,scale)),scale)}case RoundingMode.Up:{return`${sign}${shrink(Math.ceil(+enlarge(Math.abs(n),scale)),scale)}`}case RoundingMode.Down:{return`${sign}${shrink(Math.floor(+enlarge(Math.abs(n),scale)),scale)}`}case RoundingMode.HalfUp:{return(+adjust(n,scale)).toFixed(scale)}case RoundingMode.HalfDown:{const decimalArr=decimal.split("");if(/^50*$/.test(decimalArr.slice(scale).join(""))){decimalArr[scale]="1"}return(+[int,decimalArr.join("")].join(".")).toFixed(scale)}case RoundingMode.HalfEven:{const decimalArr=decimal.split("");if(/^50*$/.test(decimalArr.slice(scale).join(""))){const lastNum=decimalArr[scale-1]||int.slice(-1);if(+lastNum%2===0){decimalArr.splice(scale)}else{decimalArr[scale]="9"}}return(+[int,decimalArr.join("")].join(".")).toFixed(scale)}case RoundingMode.Unnecessary:{if(+shrink(Math.ceil(+enlarge(n,scale)),scale)===n){return String(n)}throw Error("ArithmeticException: Rounding needed with the rounding mode being set to RoundingMode.UNNECESSARY")}default:{const exhaustiveCheck=roundingMode;throw Error(`Unhandled RoundingMode: ${exhaustiveCheck}`)}}}class DecimalFormat{constructor(format="",roundingMode=RoundingMode.HalfUp){Object.defineProperty(this,"config",{enumerable:true,configurable:true,writable:true,value:void 0});Object.defineProperty(this,"roundingMode",{enumerable:true,configurable:true,writable:true,value:void 0});this.config=Object.assign({},resolveFormat(format));this.roundingMode=roundingMode}setRoundingMode(roundingMode){this.roundingMode=roundingMode}format(n){const{maxScale:maxScale,minScale:minScale,percent:percent,length:length,thousandSeparate:thousandSeparate,prefix:prefix,suffix:suffix,radixPoint:radixPoint,withSign:withSign}=this.config;let num=+n;if(Number.isNaN(num)){throw Error("not a valid number")}num=enlarge(num,Math.log10(percent));if(maxScale!==undefined){num=(+round(+num,maxScale,this.roundingMode)).toFixed(maxScale)}let[int,decimal]=num.split(".");if(length){const intMatch=int.match(/([+-]?)(\d*)/);if(intMatch){int=intMatch[1]+intMatch[2].padStart(length,"0")}}else if(int==="0"){int=""}if(thousandSeparate&&thousandSeparate<int.length){int=int.replace(new RegExp(`(\\d{1,${thousandSeparate}})(?=(?:\\d{${thousandSeparate}})+$)`,"g"),"$1,")}if(decimal){decimal=decimal.replace(/0+$/,"");if(minScale){decimal=decimal.padEnd(minScale,"0")}}num=[int,decimal].join(".");if(!radixPoint){num=num.replace(/\.$/,"")}if(withSign&&!num.startsWith("-")){num=`+${num}`}if(num===""){num=0}return`${prefix}${num}${suffix}`}}exports.RoundingMode=RoundingMode;exports.default=DecimalFormat;Object.defineProperty(exports,"__esModule",{value:true})});